<template>
  <div id="appContent">
    <!-- <div class="ui active inverted dimmer" v-if="appLoading">
      <div class="ui large text loader">Loading</div>
    </div> -->

    <router-view
      name="sidebar"
      v-if="userIsAuthenticated"
    />

    <div class="pusher">
      <router-view
        name="navbar"
        v-if="userIsAuthenticated"
      />

      <div class="column" id="content">
        <router-view name="main"/>

        <p
          class="ui horizontal divider tiny"
          id="divider"
        >
          &nbsp;&nbsp;<i class="tiny circle outline icon"></i>
        </p>

        <transition name="fade" mode="out-in">
          <router-view name="secondary"/>
        </transition>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import store from '@/store/Store'

export default {
  name: 'App',
  store,
  data () {
    return {
    }
  },
  beforeCreate () {
    if (!store.isAuthenticated) {
      store.dispatch('AuthStore/verifyToken')
        .then(
          (user) => {
          },
          (error) => {
            console.error(error.message)
            // this.$toastr.e(error.message)
            this.$router.push({ name: 'login' })
          }
        )
    }
  },
  mounted () {
    this.$toastr.defaultTimeout = 3000
    this.$toastr.defaultPosition = 'toast-top-center'

    // this.$router.beforeEach((to, from, next) => {
    //   console.log('COUCOU')
    //   next()
    // })
  },
  computed: {
    ...mapGetters({
      appLoading: 'loading',
      userIsAuthenticated: 'AuthStore/isAuthenticated'
    })
  }
}
</script>

<style>
#content {
  top: 100px;
  margin: 100px 20px 100px 20px;
}
#divider {
  margin-top: 30px
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .05s;
}
.fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
  opacity: 0;
}
</style>
